#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Reporter::Cache::Default module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Reporter::Cache::Default';

        use_ok('Tester');
        use_ok('Value::Convertor');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Reporter::Cache::Default::VERSION

my $instance = Mentat::Reporter::Cache::Default->new();
isa_ok($instance, $TESTED_CLASS);

### Viewing the created instance: $instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D(2);

my $tm = time;

diag("STC: ".Dumper($instance->set_threshold_cache(['k1'],  $tm)));
diag("CTC: ".Dumper($instance->check_threshold_cache(['k1'], ($tm-5))));
diag("CTC: ".Dumper($instance->check_threshold_cache(['k1'], ($tm-5))));

diag("CRC: ".Dumper($instance->check_relapse_cache(['k1'], ($tm+5))));
diag("CRC: ".Dumper($instance->check_relapse_cache(['k1'], ($tm+5))));
diag("CRC: ".Dumper($instance->set_relapse_cache(['k1'], ($tm+5))));

diag("CRC: ".Dumper($instance->check_relapse_cache(['k1'], ($tm+5))));
diag("CTC: ".Dumper($instance->check_threshold_cache(['k1'], ($tm-5))));

diag("CLN: ".Dumper($instance->cleanup(time)));
